function main()
{
  var app = System.GetInterface('Application');

  var OldModel = app.Models.GetObject(0);
  var NewModel = app.Models.GetObject(1);
  //The parameter in GetObject determines here with which model the script should work.
  //0 is the first model listed in the Application View.
  //1 is the second model listed in the Application View
  //etc.

  var i, OldDBOwner, NewSchema, OldEntity, NewEntity;

  for (i=0; i<OldModel.Users.Count; i++)
  {
    OldDBOwner = OldModel.Users.GetObject(i);
    if (NewModel.Schemas.GetObjectByName(OldDBOwner.Name) == null)
    {
      NewSchema = NewModel.CreateNewObject(2024);
      NewSchema.Name = OldDBOwner.Name;
    }
  }

  SetSchema(OldModel.Entities, NewModel.Entities, NewModel.Schemas); //Set Schema in Entites
  SetSchema(OldModel.Views, NewModel.Views, NewModel.Schemas); //Set Schema in Views
  SetSchema(OldModel.Procedures, NewModel.Procedures, NewModel.Schemas); //Set Schema in Procedures
  SetSchema(OldModel.Functions, NewModel.Functions, NewModel.Schemas); //Set Schema in Functions
  SetSchema(OldModel.UserDataTypes, NewModel.UserDataTypes, NewModel.Schemas); //Set Schema in UserDataTypes
  SetSchema(OldModel.Synonyms, NewModel.Synonyms, NewModel.Schemas); //Set Schema in Synonyms
  for (e=0; e<OldModel.Entities.Count; e++)
  {
    OldEntity = OldModel.Entities.GetObject(e);
    NewEntity = NewModel.Entities.GetObjectByName(OldEntity.Name);
    if (NewEntity != null)
    {
      SetSchema(OldEntity.Triggers, NewEntity.Triggers, NewModel.Schemas); //Set Schema in Entity Triggers
    }
  }

  Log.Information("DONE");
}

function SetSchema(OldObjectList, NewObjectList, NewSchemaList)
{
  var i, OldObject, NewObject, NewSchema;
  for (i=0; i<OldObjectList.Count; i++)
  {
    OldObject = OldObjectList.GetObject(i);
    NewObject = NewObjectList.GetObjectByName(OldObject.Name);
    if ((NewObject != null) && (NewObject.Schema == null) && (OldObject.DBOwner != null))
    {
      NewSchema = NewSchemaList.GetObjectByName(OldObject.DBOwner.Name);
      NewObject.SetLinkedObject("Schema", NewSchema);
    }
  }
}